var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { forwardRef, useImperativeHandle, useMemo, useRef, useEffect, } from 'react';
import { LINE_CLASSNAME } from './constants';
import Root from './root';
import Space from './space';
import useLineIndex from './use_line_index';
import { DEFAULT_PROPS } from '../../constants';
import useAutoScroll from './use_auto_scroll';
import useEvent from '../../utils/use_event';
import useScrollAction from './use_scroll_action';
const space = _jsx(Space, {});
function BaseLrc(_a, ref) {
    var { lines, lineRenderer, currentMillisecond = DEFAULT_PROPS.currentMillisecond, verticalSpace = DEFAULT_PROPS.verticalSpace, recoverAutoScrollInterval = DEFAULT_PROPS.recoverAutoScrollInterval, recoverAutoScrollSingal = DEFAULT_PROPS.recoverAutoScrollSingal, onLineUpdate, onWheel, onKeyDown, onMouseDown, onMouseUp, onMouseMove } = _a, props = __rest(_a, ["lines", "lineRenderer", "currentMillisecond", "verticalSpace", "recoverAutoScrollInterval", "recoverAutoScrollSingal", "onLineUpdate", "onWheel", "onKeyDown", "onMouseDown", "onMouseUp", "onMouseMove"]);
    const rootRef = useRef(null);
    const lineIndex = useLineIndex(lines, currentMillisecond);
    const { autoScroll, onWheel: onLocalAutoScrollWheel, onKeyDown: onLocalAutoScrollKeyDown, onMouseDown: onLocalAutoScrollMouseDown, onMouseUp: onLocalAutoScrollMouseUp, onMouseMove: onLocalAutoScrollMove, } = useAutoScroll({
        recoverAutoScrollInterval,
        recoverAutoScrollSingal,
    });
    useScrollAction({
        root: rootRef.current,
        autoScroll,
        lineIndex,
        lines,
        verticalSpace,
    });
    useEffect(() => {
        if (onLineUpdate) {
            onLineUpdate({
                index: lineIndex,
                line: lines[lineIndex] || null,
            });
        }
    }, [onLineUpdate, lineIndex, lines]);
    useImperativeHandle(ref, () => rootRef.current);
    const onWheelWrapper = useEvent((event) => {
        onLocalAutoScrollWheel();
        return onWheel && onWheel(event);
    });
    const onKeyDownWrapper = useEvent((event) => {
        onLocalAutoScrollKeyDown(event);
        return onKeyDown && onKeyDown(event);
    });
    const onMouseDownWrapper = useEvent((event) => {
        onLocalAutoScrollMouseDown();
        return onMouseDown && onMouseDown(event);
    });
    const onMouseUpWrapper = useEvent((event) => {
        onLocalAutoScrollMouseUp();
        return onMouseUp && onMouseUp(event);
    });
    const onMouseMoveWrapper = useEvent((event) => {
        onLocalAutoScrollMove();
        return onMouseMove && onMouseMove(event);
    });
    const lineNodes = useMemo(() => lines.map((line, index) => (_jsx("div", Object.assign({ className: LINE_CLASSNAME }, { children: lineRenderer({ index, active: lineIndex === index, line }) }), line.id))), [lineIndex, lineRenderer, lines]);
    return (_jsxs(Root
    /** tabIndex make focusable and enable to add keyboard listener */
    , Object.assign({ 
        /** tabIndex make focusable and enable to add keyboard listener */
        tabIndex: -1 }, props, { onWheel: onWheelWrapper, onKeyDown: onKeyDownWrapper, onMouseDown: onMouseDownWrapper, onMouseUp: onMouseUpWrapper, onMouseMove: onMouseMoveWrapper, ref: rootRef }, { children: [verticalSpace ? space : null, lineNodes, verticalSpace ? space : null] })));
}
export default forwardRef(BaseLrc);
