import { useMemo } from 'react';
import { parse, LineType } from 'clrc';
function useLrc(lrc) {
    const lines = useMemo(() => parse(lrc).filter((line) => line.type === LineType.LYRIC)
        .map((l) => ({
        id: Math.random().toString(),
        lineNumber: l.lineNumber,
        raw: l.raw,
        startMillisecond: l.startMillisecond,
        content: l.content,
    }))
        .sort((a, b) => a.startMillisecond - b.startMillisecond), [lrc]);
    return lines;
}
export default useLrc;
