import { LineType, parse } from 'clrc';
import { useMemo } from 'react';
export default (lrcs) => {
    const lines = useMemo(() => {
        const map = new Map();
        for (const lrc of lrcs) {
            const list = parse(lrc).filter((l) => l.type === LineType.LYRIC);
            for (const item of list) {
                const current = map.get(item.startMillisecond) || {
                    id: Math.random().toString(),
                    startMillisecond: item.startMillisecond,
                    children: [],
                };
                current.children.push({
                    lineNumber: item.lineNumber,
                    raw: item.raw,
                    content: item.content,
                });
                map.set(item.startMillisecond, current);
            }
        }
        return [...map.values()].sort((a, b) => a.startMillisecond - b.startMillisecond);
    }, [lrcs.length, ...lrcs]);
    return lines;
};
