import { ReactNode } from 'react';
export interface BaseLine {
    id: string;
    startMillisecond: number;
}
export interface BaseProps<Line extends BaseLine> {
    lineRenderer: ({ index, active, line, }: {
        index: number;
        active: boolean;
        line: Line;
    }) => ReactNode;
    currentMillisecond?: number;
    verticalSpace?: boolean;
    onLineUpdate?: (line: {
        index: number;
        line: Line | null;
    }) => void;
    recoverAutoScrollInterval?: number;
    recoverAutoScrollSingal?: boolean;
}
export declare const DEFAULT_PROPS: {
    readonly currentMillisecond: -1;
    readonly verticalSpace: false;
    readonly recoverAutoScrollInterval: 5000;
    readonly recoverAutoScrollSingal: false;
};
