function throttle(f, wait = 100) {
    let lastEmitTimestamp = 0;
    return (...params) => {
        const now = Date.now();
        if (now - lastEmitTimestamp >= wait) {
            lastEmitTimestamp = now;
            return f(...params);
        }
    };
}
export default throttle;
