import { useRef, useCallback } from 'react';
/**
 * stable useCallback
 * @author mebtte<hi@mebtte.com>
 */
function useEvent(callback) {
    const callbackRef = useRef();
    callbackRef.current = callback;
    const memoCallback = useCallback((...args) => callbackRef.current(...args), []);
    return memoCallback;
}
export default useEvent;
